using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using System.Net;
using System.Web;
using System.Text.RegularExpressions;

namespace TetrisOnlineLauncher
{
    class Launcher
    {
        private string authId;
        private string authPass;

        //private string server = "r-game.tetrisonline.jp";
        private string server = "tgame.tetrisonline.jp";

        //private string hserver = "http://tetris.nefficient.jp/tetris/tetrisonline_RealServer";
        //private string hserver = "http://dev1.tetrisonline.co.jp/tetris/tetrisonline_RealServer";
        private string hserver = "http://dev.tetrisonline.co.jp/tetris/tetrisonline_RealServer";

        public void StartTetrisExe()
        {
            Process.Start("tetris.exe", String.Format("enc ID={0} PW={1} ip={2}", authId, authPass, server));
        }

        public void StartPatchClient()
        {
            Process.Start("PatchClient.exe", String.Format("enc {0} {1} ip={2} {3} 11000 {4} 80",
                authId, authPass, server, server, hserver));
        }

        public void DownloadPatchClient()
        {
            WebClient wc = new WebClient();
            wc.DownloadFile(hserver + "/PatchClient.exe", "PatchClient.exe");
        }

        public void Auth(string login, string pass)
        {
            string cred = pass + ',' + login;
            string encpwd = encryptStr(cred);

            //Console.WriteLine(encpwd);

            CookieAwareWebClient wc = new CookieAwareWebClient();

            wc.Headers.Add("Content-Type", "application/x-www-form-urlencoded");
            //string data = String.Format("frmLoginID=&frmLoginPW=&formType=&idsave=0&encpwd={0}&frmRdUrl=%2Ftoj%2Fgmain%2Fteco_top.aspx&frmHost=www.tetrisonline.jp&frmOs=Mozilla%2F5.0+%28Windows%3B+U%3B+Windows+NT+6.0%3B+pl%3B+rv%3A1.9.0.3%29+Gecko%2F2008092417+Firefox%2F3.0.3+%28.NET+CLR+3.5.30729%29&frmReferer=http%3A%2F%2Fwww.tetrisonline.jp%2F&frmAffiliate=", encpwd);
            string data = String.Format("encpwd={0}", encpwd);
            wc.UploadData("http://www.tetrisonline.jp/toj/acc/tacc_login.aspx", "POST", Encoding.ASCII.GetBytes(data));

            byte[] res = wc.DownloadData("http://www.tetrisonline.jp/toj/_authchk/_authchk.aspx");

            //Console.WriteLine(Encoding.ASCII.GetString(res));

            string r = Encoding.ASCII.GetString(res);
            string[] d = r.Split(',');

            if (d.Length < 2)
                throw new Exception("Fail");

            if (d[1].Length == 0)
                throw new Exception("Login fail");

            authId = d[1];
            authPass = d[0];
        }

        private string encryptStr(string encCode)
        {
            string keyCode = "SOSY1gO7F6PK4Z63i3Kwgmc2hFy2wShBEpQMZ3kfVoh2bDswdLAzDJPCd71TGu82YcE6RSKH0F1dKIOuorNZUGJKOQIn8XpZoPPTWPotiz6QwZzJwkDC7RMohqN8SFY9jCjggxl8BxyKMLoi7pvIwAa4AmXXl6zeBZBv2lBFJU8wLeknLeK4OWaOLxdVSwQqM8ATB09oUJ7gEw4sx0tfo5bQeHj9RF3im53KX9ybpsisT4FMODfijLxPUWx60Y";
            string retString = "";
            int sumI = 0;
            string sumS;
            int bufI;
            string bufS;

            if (encCode.Length <= keyCode.Length)
            {
                for (int i = 0; i < encCode.Length; i++)
                {
                    sumI += encCode[i];
                    bufI = encCode[i] ^ keyCode[i];
                    bufS = bufI.ToString("x");

                    while (bufS.Length < 2)
                    {
                        bufS = "0" + bufS;
                    }

                    retString += bufS;
                }
            }

            int numI;
            string numS;

            sumS = sumI.ToString("x");
            numI = sumS.Length;
            numS = numI.ToString();
            retString = numS + sumS + retString;
            return retString;
        }

        public void Register(string id, string password, string email)
        {
            CookieAwareWebClient wc = new CookieAwareWebClient();

            string data;
            byte[] res;
            string r;

            string nick = id;
            string fullname = id;

            res = wc.DownloadData(String.Format("https://ssl.tetrisonline.jp/toj/acc/XidCheck.aspx?uid={0}",
                HttpUtility.UrlEncode(id)));
            r = Encoding.UTF8.GetString(res);

            if (r == "-1")
                throw new Exception("ID is already taken or invalid.");

            res = wc.DownloadData(String.Format("https://ssl.tetrisonline.jp/toj/acc/XnickCheck.aspx?nick={0}",
                HttpUtility.UrlEncode(nick)));
            r = Encoding.UTF8.GetString(res);

            if (r == "-1")
                throw new Exception("Display name is already taken or invalid.");

            res = wc.DownloadData(String.Format("https://ssl.tetrisonline.jp/toj/acc/XemailCheck.aspx?email={0}",
                HttpUtility.UrlEncode(email)));
            r = Encoding.UTF8.GetString(res);

            if (r == "-1")
                throw new Exception("Email is already in use or invalid.");

            wc.Headers.Add("Content-Type", "application/x-www-form-urlencoded");

            data = String.Format("checkid=1&checknick=1&checkemail=1&frmAffiliate=&hubrithdd=&uID={0}&uPass0={3}&uPass1={3}&uNick={2}&fhanName={4}&uEmail={1}&addrcity=%E6%B5%B7%E5%A4%96&ubrithyy=1970&ubrithmm=1&ubrithdd=1&usex=1&blood_type=AB",
                HttpUtility.UrlEncode(id), HttpUtility.UrlEncode(email),
                HttpUtility.UrlEncode(nick), HttpUtility.UrlEncode(password), HttpUtility.UrlEncode(fullname));

            res = wc.UploadData("https://ssl.tetrisonline.jp/toj/acc/tacc_regist_proc.aspx", "POST", Encoding.ASCII.GetBytes(data));
            r = Encoding.UTF8.GetString(res);

            string eventval = Regex.Match(r, "<input type=\"hidden\" name=\"__EVENTVALIDATION\" id=\"__EVENTVALIDATION\" value=\"(.*)\" />").Result("$1");
            string viewst = Regex.Match(r, "<input type=\"hidden\" name=\"__VIEWSTATE\" id=\"__VIEWSTATE\" value=\"(.*)\" />").Result("$1");

            wc.Headers.Add("Content-Type", "application/x-www-form-urlencoded");

            data = String.Format("__VIEWSTATE={5}&__EVENTVALIDATION={6}&uID={0}&uPass0={3}&uNick={2}&fhanName={4}&uEmail={1}&addrcity=%E6%B5%B7%E5%A4%96&ubrithyy=1970&ubrithmm=1&ubrithdd=1&usex=1&uReciveMail=0&uForm=0&frmHost=&frmOs=&frmReferer=&blood_type=AB&frmAffiliate=&uReciveMail1=0&uReciveMail2=0&mailtype=True&btnJoin.x=127&btnJoin.y=15",
                HttpUtility.UrlEncode(id), HttpUtility.UrlEncode(email), 
                HttpUtility.UrlEncode(nick), HttpUtility.UrlEncode(password), HttpUtility.UrlEncode(fullname),
                HttpUtility.UrlEncode(viewst), HttpUtility.UrlEncode(eventval));

            res = wc.UploadData("https://ssl.tetrisonline.jp/toj/acc/tacc_regist_proc.aspx", "POST", Encoding.ASCII.GetBytes(data));
            r = Encoding.UTF8.GetString(res);

            string userid = Regex.Match(r, "<input type=\"hidden\" name=\"userID\" id=\"userID\" value=\"(.*)\" />").Result("$1");

            if (userid == "-1")
                throw new Exception("Registration fail.");

            wc.Headers.Add("Content-Type", "application/x-www-form-urlencoded");
            data = String.Format("userID={0}",
            userid);
            res = wc.UploadData("https://ssl.tetrisonline.jp/toj/acc/tacc_regist_mailSend.aspx", "POST", Encoding.ASCII.GetBytes(data));
            r = Encoding.UTF8.GetString(res);
        }
    }
}
